=== modified file 'drizzled/function/get_system_var.cc'
--- drizzled/function/get_system_var.cc	2011-10-06 18:18:31 +0000
+++ drizzled/function/get_system_var.cc	2011-10-10 17:33:19 +0000
@@ -83,7 +83,8 @@
   }
   session->lex().setCacheable(false);
 
-  set_if_smaller(component_name->length, (size_t)MAX_SYS_VAR_LENGTH);
+  if (component_name->size() > MAX_SYS_VAR_LENGTH)
+    component_name->assign(component_name->data(), MAX_SYS_VAR_LENGTH);
 
   return new Item_func_get_system_var(var, var_type, component_name, NULL, 0);
 }

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2011-10-10 12:58:39 +0000
+++ drizzled/sql_lex.cc	2011-10-10 17:33:19 +0000
@@ -232,8 +232,7 @@
   lex->expr_allows_subselect= true;
   lex->use_only_table_context= false;
 
-  lex->name.str= 0;
-  lex->name.length= 0;
+  lex->name.assign(NULL, 0);
   lex->nest_level=0 ;
   lex->allow_sum_func= 0;
   lex->in_sum_func= NULL;
@@ -297,11 +296,11 @@
 {
   lex_string_t tmp;
   lip->yyUnget();                       // ptr points now after last token char
-  tmp.length=lip->yytoklen=length;
-  tmp.str= lip->m_session->mem.strdup(lip->get_tok_start() + skip, tmp.length);
+  tmp.str= lip->m_session->mem.strdup(lip->get_tok_start() + skip, length);
+  tmp.length= lip->yytoklen= length;
 
   lip->m_cpp_text_start= lip->get_cpp_tok_start() + skip;
-  lip->m_cpp_text_end= lip->m_cpp_text_start + tmp.length;
+  lip->m_cpp_text_end= lip->m_cpp_text_start + tmp.size();
 
   return tmp;
 }
@@ -318,8 +317,8 @@
 {
   lex_string_t tmp;
   lip->yyUnget();                       // ptr points now after last token char
-  tmp.length= lip->yytoklen=length;
-  tmp.str=(char*) lip->m_session->mem.alloc(tmp.length+1);
+  tmp.str=(char*) lip->m_session->mem.alloc(length + 1);
+  tmp.length= lip->yytoklen= length;
   const char* from= lip->get_tok_start() + skip;
   char* to= (char*)tmp.str;
   const char* end= to+length;
@@ -346,15 +345,14 @@
 */
 static char *get_text(Lex_input_stream *lip, int pre_skip, int post_skip)
 {
-  unsigned char c,sep;
   bool found_escape= false;
-  const charset_info_st * const cs= lip->m_session->charset();
+  const charset_info_st* const cs= lip->m_session->charset();
 
   lip->tok_bitmap= 0;
-  sep= lip->yyGetLast();                        // String should end with this
-  while (! lip->eof())
+  unsigned char sep= lip->yyGetLast();                        // String should end with this
+  while (not lip->eof())
   {
-    c= lip->yyGet();
+    unsigned char c= lip->yyGet();
     lip->tok_bitmap|= c;
     {
       if (use_mb(cs))
@@ -657,8 +655,7 @@
     case MY_LEX_ESCAPE:
       if (lip->yyGet() == 'N')
       {					// Allow \N as shortcut for NULL
-        yylval->lex_str.str=(char*) "\\N";
-        yylval->lex_str.length=2;
+        yylval->lex_str.assign("\\N", 2);
         return NULL_SYM;
       }
     case MY_LEX_CHAR:			// Unknown or single char token
@@ -766,8 +763,7 @@
       return(result_state);			// IDENT or IDENT_QUOTED
 
     case MY_LEX_IDENT_SEP:		// Found ident and now '.'
-      yylval->lex_str.str= (char*) lip->get_ptr();
-      yylval->lex_str.length= 1;
+      yylval->lex_str.assign(lip->get_ptr(), 1);
       c= lip->yyGet();                  // should be '.'
       lip->next_state= MY_LEX_IDENT_START;// Next is an ident (not a keyword)
       if (!ident_map[(uint8_t)lip->yyPeek()])            // Probably ` or "
@@ -900,7 +896,7 @@
       if (c != '.')
       {					// Found complete integer number.
         yylval->lex_str=get_token(lip, 0, lip->yyLength());
-      	return int_token(yylval->lex_str.str,yylval->lex_str.length);
+      	return int_token(yylval->lex_str.data(), yylval->lex_str.size());
       }
       // fall through
     case MY_LEX_REAL:			// Incomplete real number
@@ -1001,7 +997,7 @@
         state= MY_LEX_CHAR;		// Read char by char
         break;
       }
-      yylval->lex_str.length=lip->yytoklen;
+      yylval->lex_str.length= lip->yytoklen;
 
       lip->body_utf8_append(lip->m_cpp_text_start);
 
@@ -1195,9 +1191,8 @@
         lip->next_state=MY_LEX_HOSTNAME;
         break;
       }
-      yylval->lex_str.str=(char*) lip->get_ptr();
-      yylval->lex_str.length=1;
-      return((int) '@');
+      yylval->lex_str.assign(lip->get_ptr(), 1);
+      return '@';
 
     case MY_LEX_HOSTNAME:		// end '@' of user@hostname
       for (c=lip->yyGet() ;
@@ -1207,8 +1202,7 @@
       return(LEX_HOSTNAME);
 
     case MY_LEX_SYSTEM_VAR:
-      yylval->lex_str.str=(char*) lip->get_ptr();
-      yylval->lex_str.length=1;
+      yylval->lex_str.assign(lip->get_ptr(), 1);
       lip->yySkip();                                    // Skip '@'
       lip->next_state= (state_map[(uint8_t)lip->yyPeek()] ==
 			MY_LEX_USER_VARIABLE_DELIMITER ?

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2011-10-10 12:58:39 +0000
+++ drizzled/sql_parse.cc	2011-10-10 17:33:19 +0000
@@ -727,8 +727,7 @@
   init_select(&lex);
   lex.sql_command= SQLCOM_SELECT;
   lex_string_t tmp;
-  tmp.str= (char*) var_name;
-  tmp.length=strlen(var_name);
+  tmp.assign(var_name, strlen(var_name));
   /*
     We set the name of Item to @@session.var_name because that then is used
     as the column name in the output.
@@ -905,8 +904,8 @@
   if (!table)
     return NULL;				// End of memory
   const char* alias_str= alias ? alias->data() : table->table.data();
-  if (! table_options.test(TL_OPTION_ALIAS) &&
-      check_table_name(table->table.str, table->table.length))
+  if (not table_options.test(TL_OPTION_ALIAS) &&
+      check_table_name(table->table.data(), table->table.size()))
   {
     my_error(ER_WRONG_TABLE_NAME, MYF(0), table->table.str);
     return NULL;
@@ -929,7 +928,7 @@
       my_message(ER_DERIVED_MUST_HAVE_ALIAS, ER(ER_DERIVED_MUST_HAVE_ALIAS), MYF(0));
       return NULL;
     }
-    alias_str= (char*) session->mem.memdup(alias_str, table->table.length+1);
+    alias_str= (char*) session->mem.memdup(alias_str, table->table.size() + 1);
   }
   TableList *ptr = (TableList *) session->mem.calloc(sizeof(TableList));
 
@@ -1561,7 +1560,7 @@
   int well_formed_error;
   uint32_t res= cs->cset->well_formed_len(cs, str->begin(), str->end(), max_char_length, &well_formed_error);
 
-  if (!well_formed_error &&  str->length == res)
+  if (!well_formed_error &&  str->size() == res)
     return false;
 
   if (!no_error)
@@ -1590,7 +1589,7 @@
     return true;
   }
 
-  if (str->length == res)
+  if (str->size() == res)
     return false;
 
   switch (err_code)

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2011-10-10 10:13:51 +0000
+++ drizzled/sql_table.cc	2011-10-10 17:33:19 +0000
@@ -931,7 +931,7 @@
     }
 
     key_info->comment.length= key->key_create_info.comment.size();
-    if (key_info->comment.length > 0)
+    if (key_info->comment.size() > 0)
     {
       key_info->flags|= HA_USES_COMMENT;
       key_info->comment.str= (char*)key->key_create_info.comment.data();

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-08-19 07:50:07 +0000
+++ drizzled/sql_yacc.yy	2011-10-10 17:33:19 +0000
@@ -1150,8 +1150,7 @@
 row_format_or_text:
           row_format
           {
-            $$.str= YYSession->mem.strdup($1.str, $1.length);
-            $$.length= $1.length;
+            $$.assign(YYSession->mem.strdup($1.str, $1.length), $1.length);
           }
         ;
 
@@ -2010,9 +2009,9 @@
               DRIZZLE_YYABORT;
             }
 
-            if (check_table_name($3->table.str,$3->table.length))
+            if (check_table_name($3->table.data(), $3->table.size()))
             {
-              my_error(ER_WRONG_TABLE_NAME, MYF(0), $3->table.str);
+              my_error(ER_WRONG_TABLE_NAME, MYF(0), $3->table.data());
               DRIZZLE_YYABORT;
             }
 
@@ -2344,7 +2343,7 @@
             if ($4.str)
             {
               $2->is_autogenerated_name= false;
-              $2->set_name($4.str, $4.length, system_charset_info);
+              $2->set_name($4.data(), $4.size(), system_charset_info);
             }
             else if (!$2->name)
             {
@@ -2686,9 +2685,7 @@
         | function_call_conflict
         | simple_expr COLLATE_SYM ident_or_text %prec UMINUS
           {
-            Item *i1= new (YYSession->mem_root) Item_string($3.str,
-                                                      $3.length,
-                                                      YYSession->charset());
+            Item *i1= new (YYSession->mem_root) Item_string($3.data(), $3.size(), YYSession->charset());
             $$= new (YYSession->mem_root) Item_func_set_collation($1, i1);
           }
         | literal
@@ -3083,7 +3080,7 @@
 function_call_generic:
           IDENT_sys '('
           {
-            const plugin::Function *udf= plugin::Function::get(std::string($1.str, $1.length));
+            const plugin::Function *udf= plugin::Function::get(std::string($1.data(), $1.size()));
 
             /* Temporary placing the result of getFunction in $3 */
             $<udf>$= udf;
@@ -3153,7 +3150,7 @@
             if ($4.str)
             {
               $2->is_autogenerated_name= false;
-              $2->set_name($4.str, $4.length, system_charset_info);
+              $2->set_name($4.data(), $4.size(), system_charset_info);
             }
             else
               $2->set_name($1, (uint) ($3 - $1), YYSession->charset());
@@ -3825,11 +3822,11 @@
           ident
           {
             $$= new List<String>;
-            $$->push_back(new (YYSession->mem_root) String($1.str, $1.length, system_charset_info));
+            $$->push_back(new (YYSession->mem_root) String($1.data(), $1.size(), system_charset_info));
           }
         | using_list ',' ident
           {
-            $1->push_back(new (YYSession->mem_root) String($3.str, $3.length, system_charset_info));
+            $1->push_back(new (YYSession->mem_root) String($3.data(), $3.size(), system_charset_info));
             $$= $1;
           }
         ;
@@ -4080,9 +4077,9 @@
         ;
 
 limit_option:
-          ULONGLONG_NUM { $$= new Item_uint($1.str, $1.length); }
-        | LONG_NUM      { $$= new Item_uint($1.str, $1.length); }
-        | NUM           { $$= new Item_uint($1.str, $1.length); }
+          ULONGLONG_NUM { $$= new Item_uint($1.data(), $1.size()); }
+        | LONG_NUM      { $$= new Item_uint($1.data(), $1.size()); }
+        | NUM           { $$= new Item_uint($1.data(), $1.size()); }
         ;
 
 delete_limit_clause:
@@ -4623,7 +4620,7 @@
           /* empty */
         | LIKE TEXT_STRING_sys
           {
-            Lex.wild= new (YYSession->mem_root) String($2.str, $2.length, system_charset_info);
+            Lex.wild= new (YYSession->mem_root) String($2.data(), $2.size(), system_charset_info);
           }
         | WHERE expr
           {
@@ -4666,7 +4663,7 @@
         | text_string { Lex.wild= $1; }
         | ident
           {
-            Lex.wild= new (YYSession->mem_root) String($1.str, $1.length, system_charset_info);
+            Lex.wild= new (YYSession->mem_root) String($1.data(), $1.size(), system_charset_info);
           }
         ;
 
@@ -4910,24 +4907,22 @@
 text_literal:
         TEXT_STRING_literal
         {
-          $$ = new Item_string($1.str, $1.length, YYSession->variables.getCollation());
+          $$ = new Item_string($1.data(), $1.size(), YYSession->variables.getCollation());
         }
         | text_literal TEXT_STRING_literal
           {
-            ((Item_string*) $1)->append($2.str, $2.length);
+            ((Item_string*) $1)->append($2.str, $2.size());
           }
         ;
 
 text_string:
           TEXT_STRING_literal
           {
-            $$= new (YYSession->mem_root) String($1.str,
-                                             $1.length,
-                                             YYSession->variables.getCollation());
+            $$= new (YYSession->mem_root) String($1.data(), $1.size(), YYSession->variables.getCollation());
           }
         | HEX_NUM
           {
-            Item *tmp= new Item_hex_string($1.str, $1.length);
+            Item *tmp= new Item_hex_string($1.data(), $1.size());
             /*
               it is OK only emulate fix_fields, because we need only
               value of constant
@@ -4938,7 +4933,7 @@
           }
         | BIN_NUM
           {
-            Item *tmp= new Item_bin_string($1.str, $1.length);
+            Item *tmp= new Item_bin_string($1.data(), $1.size());
             /*
               it is OK only emulate fix_fields, because we need only
               value of constant
@@ -4968,16 +4963,16 @@
           }
         | FALSE_SYM { $$= new drizzled::item::False(); }
         | TRUE_SYM { $$= new drizzled::item::True(); }
-        | HEX_NUM { $$ = new Item_hex_string($1.str, $1.length);}
-        | BIN_NUM { $$= new Item_bin_string($1.str, $1.length); }
+        | HEX_NUM { $$ = new Item_hex_string($1.data(), $1.size());}
+        | BIN_NUM { $$= new Item_bin_string($1.data(), $1.size()); }
         | DATE_SYM text_literal { $$ = $2; }
         | TIMESTAMP_SYM text_literal { $$ = $2; }
         ;
 
 integer_literal:
           text_literal { $$ = $1; }
-        | HEX_NUM { $$ = new Item_hex_string($1.str, $1.length);}
-        | BIN_NUM { $$= new Item_bin_string($1.str, $1.length); }
+        | HEX_NUM { $$ = new Item_hex_string($1.data(), $1.size());}
+        | BIN_NUM { $$= new Item_bin_string($1.data(), $1.size()); }
         | NUM_literal { $$ = $1; }
         | NULL_SYM
           {
@@ -5024,18 +5019,18 @@
           NUM
           {
             int error;
-            $$ = new Item_int($1.str, (int64_t) internal::my_strtoll10($1.str, NULL, &error), $1.length);
+            $$ = new Item_int($1.data(), internal::my_strtoll10($1.data(), NULL, &error), $1.size());
           }
         | LONG_NUM
           {
             int error;
-            $$ = new Item_int($1.str, (int64_t) internal::my_strtoll10($1.str, NULL, &error), $1.length);
+            $$ = new Item_int($1.data(), internal::my_strtoll10($1.data(), NULL, &error), $1.size());
           }
         | ULONGLONG_NUM
-          { $$ = new Item_uint($1.str, $1.length); }
+          { $$ = new Item_uint($1.data(), $1.size()); }
         | DECIMAL_NUM
           {
-            $$= new Item_decimal($1.str, $1.length, YYSession->charset());
+            $$= new Item_decimal($1.data(), $1.size(), YYSession->charset());
             if (YYSession->is_error())
             {
               DRIZZLE_YYABORT;
@@ -5043,7 +5038,7 @@
           }
         | FLOAT_NUM
           {
-            $$ = new Item_float($1.str, $1.length);
+            $$ = new Item_float($1.data(), $1.size());
             if (YYSession->is_error())
             {
               DRIZZLE_YYABORT;
@@ -5155,13 +5150,10 @@
           {
             const charset_info_st * const cs= system_charset_info;
             int dummy_error;
-            uint32_t wlen= cs->cset->well_formed_len(cs, $1.str,
-                                                 $1.str+$1.length,
-                                                 $1.length, &dummy_error);
-            if (wlen < $1.length)
+            uint32_t wlen= cs->cset->well_formed_len(cs, $1.begin(), $1.end(), $1.size(), &dummy_error);
+            if (wlen < $1.size())
             {
-              my_error(ER_INVALID_CHARACTER_STRING, MYF(0),
-                       cs->csname, $1.str + wlen);
+              my_error(ER_INVALID_CHARACTER_STRING, MYF(0), cs->csname, $1.data() + wlen);
               DRIZZLE_YYABORT;
             }
             $$= $1;
@@ -5193,8 +5185,7 @@
           IDENT_sys    { $$=$1; }
         | keyword
           {
-            $$.str= YYSession->mem.strdup($1.str, $1.length);
-            $$.length= $1.length;
+            $$.assign(YYSession->mem.strdup($1.str, $1.length), $1.length);
           }
         ;
 
@@ -5476,8 +5467,7 @@
 internal_variable_ident:
           keyword_exception_for_variable
           {
-            $$.str= YYSession->mem.strdup($1.str, $1.length);
-            $$.length= $1.length;
+            $$.assign(YYSession->mem.strdup($1.str, $1.length), $1.length);
           }
         | IDENT_sys    { $$=$1; }
         ;
@@ -5488,7 +5478,7 @@
             /* We have to lookup here since local vars can shadow sysvars */
             {
               /* Not an SP local variable */
-              sys_var *tmp= find_sys_var(std::string($1.str, $1.length));
+              sys_var *tmp= find_sys_var(std::string($1.data(), $1.size()));
               if (!tmp)
                 DRIZZLE_YYABORT;
               $$.var= tmp;

=== modified file 'drizzled/statement/execute.cc'
--- drizzled/statement/execute.cc	2011-10-10 09:54:42 +0000
+++ drizzled/statement/execute.cc	2011-10-10 17:33:19 +0000
@@ -96,7 +96,7 @@
 
 bool statement::Execute::execute_shell()
 {
-  if (to_execute.length == 0)
+  if (to_execute.size() == 0)
   {
     my_error(ER_WRONG_ARGUMENTS, MYF(0), "Invalid Variable");
     return false;
@@ -138,12 +138,12 @@
         if (session().inTransaction())
         {
           // @todo Figure out something a bit more solid then this.
-          start_sql.append("SAVEPOINT execute_internal_savepoint");
+          start_sql= "SAVEPOINT execute_internal_savepoint";
           is_savepoint= true;
         }
         else
         {
-          start_sql.append("START TRANSACTION");
+          start_sql= "START TRANSACTION";
         }
 
         error_occured= runStatement(*null_client, start_sql);

